<?php

// main FWD Mega Zoom & Pan Image zoomer plugin class
class FWDZOOMER{
	
	// constants
	const MIN_WP_VER =  "3.5.0";
	const CAPABILITY = "edit_fwdzoomer";
	const VERSION = '3.0';
	
	// variables
	private $_data;
	private $_dir_url;
	private $_is_Ligtbox_initialized = FALSE;
    
    private static $_zoomer_id = 0;
	private static $_image_name = 0;
    private static $_pl_id = 0;

    
    // constructor
    public function init(){
	
		$this->_dir_url = plugin_dir_url(dirname(__FILE__));
		
    	// set hooks
    	add_action("admin_menu", array($this, "add_plugin_menu"));
		add_action("wp_enqueue_scripts", array($this, "add_header_files"));
		add_shortcode("fwdzoomer", array($this, "setZoomer"));
	
		// set data
		$this->_data = new FWDZoomerData();
		$this->_data->init();
    }
	
    // functions
    public function add_plugin_menu(){
		
    	// add menus
        add_menu_page("Mega Zoom & Pan Image zoomer", "Mega Zoom & Pan Image zoomer", FWDZOOMER::CAPABILITY, "FWDZOOMERMenu-General-Settings", array($this, "set_general_settings"), $this->_dir_url . "content/icons/menu-icon.png");
       	
		add_submenu_page("FWDZOOMERMenu-General-Settings", "General settings", "General settings", FWDZOOMER::CAPABILITY, "FWDZOOMERMenu-General-Settings");
        
		add_submenu_page("FWDZOOMERMenu-General-Settings", "Images manager", "Images manager", FWDZOOMER::CAPABILITY, "FWDZOOMERMenu-Playlists-Manager", array($this, "set_playlists_manager"));
		
		add_submenu_page("FWDZOOMERMenu-General-Settings", "Markers manager", "Markers manager", FWDZOOMER::CAPABILITY, "FWDZOOMERMenu-Markers-Manager", array($this, "set_markers_manager"));
        
		add_submenu_page("FWDZOOMERMenu-General-Settings", "CSS Editor", "CSS Editor", FWDZOOMER::CAPABILITY, "FWDZOOMERMenu-CSS-Editor", array($this, "set_css_editor"));
       	

		// add meta boxes
        $post_type_screens = array("post", "page");
       	$args = array(
	       'public'   => true,
	       '_builtin' => false,
	    );
       	$custom_post_types = get_post_types($args);

       	foreach ($custom_post_types as $screen){
       		$post_type_screens[] = $screen;
       	}

    	foreach($post_type_screens as $screen){
       		add_meta_box("FWDZOOMER-shortcode-generator", "FWDZOOMER Shortcode Generator",  array($this, "set_custom_meta_box"), $screen, "side", "default");
    	}
    }
	
    public function add_header_files(){
     	global $post, $wpdb;
     	if(empty($post)) return;

		$shortcode_found = false;
       	if(has_shortcode($post->post_content, 'fwdzoomer')){
          	$shortcode_found = true;
       	}else if(isset($post->ID)){ 
          	$result = $wpdb->get_var($wpdb->prepare(
            "SELECT count(*) FROM $wpdb->postmeta " .
            "WHERE post_id = %d and meta_value LIKE '%%fwdzoomer%%'", $post->ID));
          	$shortcode_found = !empty($result);
       	}
       
		if (!empty($shortcode_found)){
			wp_enqueue_script("FWDZOOMER_rl_script", $this->_dir_url . "js/FWDM.js", array(), FWDZOOMER::VERSION);
			wp_enqueue_style("FWDZOOMER_rl_css", $this->_dir_url . "css/global.css", array(), FWDZOOMER::VERSION);
		}		
	}
    
	private function check_wp_ver(){
	    global $wp_version;
	    
		$exit_msg = "The Mega Zoom & Pan Image zoomer plugin requires WordPress " . FWDZOOMER::MIN_WP_VER . " or newer. <a href='http://codex.wordpress.org/Updating_WordPress'>Please update!</a>";
		
		if (version_compare($wp_version, FWDZOOMER::MIN_WP_VER) <= 0){
			echo $exit_msg;
			return false;
		}
		return true;
	}

    public function set_general_settings(){
    	if (!$this->check_wp_ver()){
    		return;
    	}
    	
    	$msg = "";
    	
    	$set_id = 0;
		$set_order_id = 0;
		$tab_init_id = 0;
    	
	    if (!empty($_POST) && check_admin_referer("FWDZOOMER_general_settings_update", "FWDZOOMER_general_settings_nonce")){
			$data_obj = json_decode(str_replace("\\", "", $_POST["settings_data"]), true);
			
			$action = $data_obj["action"];
			$settingsAr = $data_obj["settings_ar"];


			//validate input
			foreach ($settingsAr as $key => $value) {

				
				if(!empty($settingsAr[$key]["name"])){
					$settingsAr[$key]["name"] = sanitize_text_field($settingsAr[$key]["name"]);
				}

				if(!empty($settingsAr[$key]["start_zoom_factor"])){
					$settingsAr[$key]["start_zoom_factor"] = sanitize_text_field($settingsAr[$key]["start_zoom_factor"]);
				}

				if(!empty($settingsAr[$key]["preloaderWidth"])){
					$settingsAr[$key]["preloaderWidth"] = sanitize_text_field($settingsAr[$key]["preloaderWidth"]);
				}

				if(!empty($settingsAr[$key]["buttons"])){
					$settingsAr[$key]["buttons"] = sanitize_text_field($settingsAr[$key]["buttons"]);
				}

				if(!empty($settingsAr[$key]["buttons_tool_tips"])){
					$settingsAr[$key]["buttons_tool_tips"] = sanitize_text_field($settingsAr[$key]["buttons_tool_tips"]);
				}

				if(!empty($settingsAr[$key]["context_menu_labels"])){
					$settingsAr[$key]["context_menu_labels"] = sanitize_text_field($settingsAr[$key]["context_menu_labels"]);
				}
				
			}
			
			$this->_data->settings_ar = $settingsAr;
			$this->_data->set_data();
			
			switch ($action){
			    case "add":
			        $msg = "<div class='fwd-updated'><p style='padding:8px;'>Your new preset has been added!</p></div>";
			        $set_id = $data_obj["set_id"];
					$set_order_id = $data_obj["set_order_id"];
					$tab_init_id = $data_obj["tab_init_id"];
			        break;
			    case "save":
			        $msg = "<div class='fwd-updated'><p style='padding:8px;'>Your preset settings have been updated!</p></div>";
			        $set_id = $data_obj["set_id"];
					$set_order_id = $data_obj["set_order_id"];
					$tab_init_id = $data_obj["tab_init_id"];
			        break;
			    case "del":
			       	$msg = "<div class='fwd-updated'><p style='padding:8px;'>Your preset has been deleted!</p></div>";
			        break;
			}
		}
		
		// jquery ui
		wp_enqueue_style("FWDZOOMER_fwd_ui_css", $this->_dir_url . "css/fwd_ui.css", array(), '1.10.4');
		wp_enqueue_script("FWDZOOMER_fwdtooltip", $this->_dir_url . "js/fwdtooltip.js", array(), '1.0');
		wp_enqueue_script("jquery-ui-tabs");
		
		// spectrum colorpicker
    	wp_enqueue_style("FWDZOOMER_spectrum_css", $this->_dir_url . "css/spectrum.css");
    	wp_enqueue_script("FWDZOOMER_spectrum_script", $this->_dir_url . "js/spectrum.js");
    	
    	// general settings script
		wp_enqueue_media();
        wp_enqueue_script("FWDZOOMER_general_settings_script", $this->_dir_url . "js/general_settings.js", array(), FWDZOOMER::VERSION);
		
    	include_once "general_settings.php";
    }
	
	public function set_markers_manager(){

    	if (!$this->check_wp_ver()){
    		return;
    	}
    	
    	$msg = "";
		
	    if (!empty($_POST) && check_admin_referer("fwdzoomer_marker_manager_update", "fwdzoomer_marker_manager_nonce")){
			$mainMarkerssAr = json_decode(str_replace("\\", "", $_POST["marker_data"]), true);
			$this->_data->main_markers_ar = $mainMarkerssAr;
			$this->_data->set_data();
			$msg = "<div class='fwd-updated'><p style='padding:8px;'>Your markers have been updated!</p></div>";
		}
		
		// jquery ui
		wp_enqueue_style("FWDZOOMER_fwd_ui_css", $this->_dir_url . "css/fwd_ui.css", array(), '1.10.4');
		wp_enqueue_script("FWDZOOMER_fwdtooltip", $this->_dir_url . "js/fwdtooltip.js", array(), '1.0');
		wp_enqueue_script("jquery-ui-sortable");
		wp_enqueue_script("jquery-ui-accordion");
		wp_enqueue_script("jquery-ui-dialog");
		
		// Image manager script
		wp_enqueue_media();
        wp_enqueue_script("FWDZOOMER_marker_manager_script", $this->_dir_url . "js/markers_manager.js", array(), FWDZOOMER::VERSION);
        
    	include_once "marker_manager.php";
	}
    
 	public function set_playlists_manager(){

    	if (!$this->check_wp_ver()){
    		return;
    	}
    	
    	$msg = "";
		
	    if (!empty($_POST) && check_admin_referer("fwdzoomer_prodcut_manager_update", "fwdzoomer_product_manager_nonce")){
			$mainPlaylistsAr = json_decode(str_replace("\\", "", $_POST["product_data"]), true);
			$this->_data->main_prodcuts_ar = $mainPlaylistsAr;
			$this->_data->set_data();
			
			$msg = "<div class='fwd-updated'><p style='padding:8px;'>Your images have been updated!</p></div>";
		}
		
		// jquery ui
		wp_enqueue_style("FWDZOOMER_fwd_ui_css", $this->_dir_url . "css/fwd_ui.css", array(), '1.10.4');
		wp_enqueue_script("FWDZOOMER_fwdtooltip", $this->_dir_url . "js/fwdtooltip.js", array(), '1.0');
		wp_enqueue_script("jquery-ui-sortable");
		wp_enqueue_script("jquery-ui-accordion");
		wp_enqueue_script("jquery-ui-dialog");
		
		// Image manager script
		wp_enqueue_media();
        wp_enqueue_script("FWDZOOMER_product_manager_script", $this->_dir_url . "js/product_manager.js", array(), FWDZOOMER::VERSION);
		wp_enqueue_script("FWDZOOMER", $this->_dir_url . "js/FWDM.js", array(), FWDZOOMER::VERSION);
        
    	include_once "product_manager.php";
    }
    
    public function set_css_editor(){
    	if (!$this->check_wp_ver()){
    		return;
    	}
    	
    	$msg = "";
    	$scroll_pos = 0;
    	
    	$css_file = plugin_dir_path(dirname(__FILE__)) . "css/global.css";
    	
	    if (!empty($_POST) && check_admin_referer("FWDZOOMER_css_editor_update", "FWDZOOMER_css_editor_nonce")){
			$handle = fopen($css_file, "w") or die("Cannot open file: " . $css_file);
			
			$data = stripslashes($_POST["css_data"]);
			$scroll_pos = $_POST["scroll_pos"];
			
			fwrite($handle, $data);
			
			$msg = "<div class='fwd-updated'><p style='padding:8px;'>The CSS file has been updated!</p></div>";
		}
		
		wp_enqueue_style("FWDZOOMER_fwd_ui_css", $this->_dir_url . "css/global.css");
	  			
		$handle = fopen($css_file, "r") or die("Cannot open file: " . stripslashes($css_file));
        
    	include_once "css_editor.php";
    	
    	fclose($handle);
    }
	
	public static function set_action_links($links){
		$settings_link = "<a href='" . get_admin_url(null, "admin.php?page=FWDZOOMERMenu-General-Settings") . "'>Settings</a>";
   		array_unshift($links, $settings_link);
   		
   		return $links;
	}
    
    
	public function setZoomer($atts){
		
		extract(shortcode_atts(array("preset_name" => 0, "image_name" => 0, "opener" => "", "auto_open" => ""), $atts, "fwdzoomer"));
		
		$zoomer_div = "<div id='zoomerDiv" . FWDZOOMER::$_zoomer_id. "'></div>";
		
		$FWDZOOMER_constructor = $this->get_constructor($preset_name, $image_name);
		$infoAndMarkersId = $this->getInfoWindowAndMarkers($preset_name, $image_name);
		
		FWDZOOMER::$_zoomer_id ++;	
		$rl_output = $zoomer_div . $infoAndMarkersId . $FWDZOOMER_constructor;
	
		return $rl_output;
	}
	
	public function set_custom_meta_box($post){
		if (!$this->check_wp_ver()){
    		return;
    	}
		
		// presets
		$presetsNames = array();
		
		foreach ($this->_data->settings_ar as $setting){
    		$el = array(
						"id" => $setting["id"],
						"name" => $setting["name"]
				   );
    				   
    		array_push($presetsNames, $el);
    	}
    	
		// playlists
		$mainPlaylistsNames = array();
		
		if (isset($this->_data->main_prodcuts_ar)){
			foreach ($this->_data->main_prodcuts_ar as $main_playlist){
	    		$el = array(
	    				"id" => $main_playlist["id"],
	    				"name" => $main_playlist["name"]
	    			);
	    				   
	    		array_push($mainPlaylistsNames, $el);
	    	}
		}
		
    	wp_enqueue_style("FWDZOOMER_fwd_ui_css", $this->_dir_url . "css/fwd_ui.css", array(), FWDZOOMER::VERSION);
		wp_enqueue_script("FWDZOOMER_shortcode_script", $this->_dir_url . "js/shortcode.js", array(), FWDZOOMER::VERSION);
		
    	include_once "meta_box.php";
	}
	
	public function get_constructor($presetName, $imageName) {
    	$preset = NULL;
		$finalString = "";
		$isLightbox = 0;
    	
    	foreach ($this->_data->settings_ar as $set){

    		if ($set["name"] == $presetName){
    			$preset = $set;
			
				if($set["display_type"] == "lightbox") $isLightbox = 1;
    		}
    	}
    
    	if (is_null($preset)){
    		return "<br><br>Mega Zoom & Pan Image Viewer with preset id <span style='color:#FF0000;'>". $presetName . " </span>does not exist!";
    	}
    	
    	$main_playlist = NULL;
  
    	foreach ($this->_data->main_prodcuts_ar as $pl){
    		if ($pl["name"] == $imageName){
    			$main_playlist = $pl;
				
    		}
		}
		
		if (is_null($main_playlist)){
    		return "<br><br>Mega Zoom & Pan Image Zoomer image with id <span style='color:#FF0000;' '>". $imageName . "</span> does not exist!";
    	}
		
		$FWDZOOMERConstructor = "<script type='text/javascript'>document.addEventListener('DOMContentLoaded', function(){";
			if($preset['display_type'] != 'lightbox'){
				$FWDZOOMERConstructor .= "setupFWDZoomer" . FWDZOOMER::$_zoomer_id . "();";
			}
		$FWDZOOMERConstructor .= "});";


		$FWDZOOMERConstructor .= "function setupFWDZoomer" . FWDZOOMER::$_zoomer_id . "(){window.FWDZOOMER" . FWDZOOMER::$_zoomer_id. " = new FWDM({" . "skinPath:'" . $this->_dir_url . "content/" . $preset['skin_path']  ."',parentId:'zoomerDiv" . FWDZOOMER::$_zoomer_id . "',markersAndInfoWindowId:'markersAndInfoWindow" . FWDZOOMER::$_zoomer_id . "',imagePath:'" . $main_playlist['imageSource'] . "',displayType:'" . $preset['display_type'] . "',autoScale:'" . $preset['auto_scale'] . "',zoomerWidth:" . $preset['viewer_width'] . ",zoomerHeight:" . $preset['viewer_height'] . ",imageOffsetX:" . $preset['imageOffsetX'] . ",imageOffsetY:" . $preset['imageOffsetY'] . ",zoomSpeed:" . $preset['zoomSpeed'] . ",preloaderText:'" . $preset['preloaderText'] . "',initializeOnlyWhenVisible:'" . $preset['initializeOnlyWhenVisible'] . "',preloaderBackgroundSize:'" . $preset['preloaderBackgroundSize'] . "',useEntireScreen:'" . $preset['use_entire_screen'] . "',useVectorIcons:'" . $preset['useVectorIcons'] . "',addDoubleClickSupport:'" . $preset['add_double_click_support'] . "',disableMouseWheel:'" . $preset['disable_mouse_wheel'] . "',doubleClickZoomFactor:" . $preset["doubleClickZoomFactor"] . ",imageWidth:" . $main_playlist["image_width"] . ",imageHeight:" . $main_playlist["image_height"] . ",zoomFactor:" . $preset['zoom_factor'] . ",startZoomFactor:'" . $preset['start_zoom_factor'] . "',panSpeed:" . $preset['pan_speed'] . ",fullscreenBackgroundColor:'" . $preset['fullscreenBackgroundColor'] . "',backgroundColorOnZoom:'" . $preset['backgroundColorOnZoom'] . "',backgroundColor:'" . $preset['background_color']  . "',lightBoxWidth:" . $preset['light_box_width'] . ",lightBoxHeight:" . $preset['light_box_height'] . ",lightBoxBackgroundOpacity:" . $preset['light_box_background_opacity'] . ",lightBoxBackgroundColor:'" . $preset['light_box_background_color'] . "',buttons:'" . $preset['buttons'] . "',buttonsToolTips:'" . $preset['buttons_tool_tips'] . "',controllerHorizontalPosition:'" . $preset['controllerHorizontalPosition'] . "',showControllerBackground:'" . $preset['showControllerBackground'] . "',controllerVerticalPosition:'" . $preset['controllerVerticalPosition'] . "',preloaderOffsetX:" . $preset['preloaderOffsetX'] . ",preloaderOffsetY:" . $preset['preloaderOffsetY'] . ",preloaderWidth:'" . $preset['preloaderWidth'] . "',preloaderFontColor:'" . $preset['preloaderFontColor'] . "',preloaderPosition:'" . $preset['preloaderPosition'] . "',showPreloaderProgressBar:'" . $preset['showPreloaderProgressBar'] . "',preloaderBackgroundColor:'" . $preset['preloaderBackgroundColor'] . "',preloaderProgressBarBackgroundColor:'" . $preset['preloaderProgressBarBackgroundColor'] . "',preloaderProgressBarFillColor:'" . $preset['preloaderProgressBarFillColor'] . "',preloaderWindowBackgroundOpacity:" . $preset['preloaderWindowBackgroundOpacity'] . ",inversePanDirection:'" . $preset['inverse_pan_direction'] . "',addKeyboardSupport:'" . $preset['add_keyboard_support'] . "',startSpaceBetweenButtons:" . $preset['space_between_buttons'] . ",buttonsToolTipOffsetY:" . $preset['buttons_tool_tip_offset_y'] . ",spaceBetweenButtons:" . $preset['space_between_buttons'] . ",startSpaceForScrollBarButtons:" . $preset['start_space_for_scroll_bar_buttons'] . ",startSpaceForScrollBar:" . $preset['start_space_for_scroll_bar'] . ",hideControllerDelay:" . $preset['hide_controller_delay'] . ",controllerMaxWidth:" . $preset['controller_max_width'] . ",controllerBackgroundOpacity:" . $preset['controller_background_opacity'] . ",controllerOffsetWidth:" . $preset['controllerOffsetWidth'] . ",controllerOffsetY:" . $preset['controller_offset_y'] . ",scrollBarHandlerOffsetX:" . $preset['scrollBarHandlerOffsetX'] . ",startSpaceBetweenButtons:" . $preset['startSpaceBetweenButtons'] . ",scrollBarOffsetX:" . $preset['scroll_bar_offset_x'] . ",buttonToolTipBackgroundColor:'" . $preset['buttonToolTipBackgroundColor'] . "',buttonToolTipFontColor:'" . $preset['button_tool_tip_font_color'] . "',scrollBarHandlerToolTipOffsetY:" . $preset['scroll_bar_handler_tool_tip_offset_y'] . ",zoomInAndOutToolTipOffsetY:" . $preset['zoom_in_and_out_tool_tip_offset_y'] . ",showNavigator:'" . $preset['show_navigator'] . "',navigatorWidth:'" . $preset['navigatorWidth'] . "',navigatorPosition:'" . $preset['navigator_position'] . "',navigatorOffsetX:" . $preset['navigator_offset_x'] . ",navigatorOffsetY:" . $preset['navigator_offset_y'] . ",navigatorBackgroundColor:'" . $preset['navigatorBackgroundColor'] . "',navigatorHandlerColor:'" . $preset['navigator_handler_color'] . "',navigatorBorderColor:'" . $preset['navigator_border_color'] . "',infoWindowBackgroundOpacity:" . $preset['info_window_background_opacity'] . ",infoWindowWidth:'" . $preset['infoWindowWidth'] . "',infoWindowBackgroundColor:'" . $preset['info_window_background_color'] . "',infoWindowScrollBarColor:'" . $preset['info_window_scroll_bar_color'] . "',showMarkersInfo:'no',markerToolTipOffsetY:" . $preset['marker_tool_tip_offset_y'] . ",showScriptDeveloper:'"  . $preset['showScriptDeveloper'] . "',contextMenuLabels:'" . $preset['context_menu_labels'] . "',contextMenuBorderColor:'" . $preset['contextMenuBorderColor'] . "',contextMenuSpacerColor:'" . $preset['contextMenuSpacerColor'] . "',contextMenuItemTextNormalColor:'" . $preset['contextMenuItemTextNormalColor'] . "',contextMenuItemTextSelectedColor:'" . $preset['contextMenuItemTextSelectedColor'] . "',contextMenuItemBackgroundNormalColor:'" . $preset['contextMenuItemBackgroundNormalColor'] . "',contextMenuItemBackgroundSelectedColor:'" . $preset['contextMenuItemBackgroundSelectedColor'] . "',contextMenuItemDisabledColor:'" . $preset['contextMenuItemDisabledColor'] . "'});};</script>";
		
		return $FWDZOOMERConstructor;
    }
    
    public function getInfoWindowAndMarkers($presetName, $imageName){
    	$main_playlist = NULL;
		$preset = NULL;
		$hasLargeSource = false;
		$hasNavigatorSource = false;
		if(empty($this->_data->main_prodcuts_ar)) return;
    	
    	foreach ($this->_data->main_prodcuts_ar as $pl){
    		if ($pl["name"] == $imageName){
    			$main_playlist = $pl;
    		}
    	}
		
    	if (is_null($main_playlist)){
    		return "<br><br>Mega Zoom & Pan Image Zoomer image with id <span style='color:#FF0000;' '>". $imageName . "</span> does not exist!";
    	}
		
		foreach ($this->_data->settings_ar as $set){
    		if ($set["name"] == $presetName){
    			$preset = $set;
				$curPreset = $set;
    		}
    	}
		 
		$main_product_str = "";

		$main_product_str .= "<div id='markersAndInfoWindow" . FWDZOOMER::$_zoomer_id . "' style='display:none;'>";
		
		$main_product_str .=  "<div data-info=''>" . $main_playlist['infoWindowText']. "</div>";
	
		//add markers 
		$main_product_str .=  "<ul data-markers=''>";		
		foreach ($main_playlist['markers'] as $marker){
			foreach ($this->_data->main_markers_ar as $markerData){
				if($markerData['name'] == $marker['text']){
					if($markerData["type"] == "link"){
						$main_product_str .= "<li data-marker-type='"  . $markerData['type'] . "' data-show-after-zoom-factor='" . $markerData['dataZoomAfterFactor'] . "' data-marker-url='" . $markerData['url'] . "' data-marker-target='" . $markerData['target'] . "' data-marker-id='fwd360pv" . $markerData['name'] .  "' data-reg-point='" . $markerData['regpoint']  . "' data-marker-width='" . $preset['marker_width'] .  "' data-marker-height='" . $preset['marker_height'] . "' data-tooltip-offset-x='" . $marker['offsetX'] . "' data-marker-left=\"" . $marker['x'] . "\" data-marker-top=\"" . $marker['y'] .  "\"  data-tool-tip-label=\"" . $markerData['text'] . "\" data-marker-normal-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker3.png" . "' data-marker-selected-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker3-rollover.png" . "'></li>";
					}else if($markerData["type"] == "tooltip-plus"){
						$main_product_str .= "<li data-marker-type='"  . $markerData['type'] . "' data-show-after-zoom-factor='" . $markerData['dataZoomAfterFactor'] . "' data-marker-id='fwd360pv" . $markerData['name'] . "' data-reg-point='" . $markerData['regpoint'] . "' data-marker-window-width='" . $markerData['window_width'] . "' data-marker-width='" . $preset['marker_width'] .  "' data-marker-height='" . $preset['marker_height'] . "' data-tooltip-offset-x='" . $marker['offsetX'] . "' data-marker-left=\"" . $marker['x'] . "\" data-marker-top=\"" . $marker['y'] . "\" data-marker-normal-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker1.png" . "' data-marker-selected-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker1-rollover.png" . "'>" .  $markerData['text'] . "</li>";
					}else if($markerData["type"] == "tooltip-play"){
						$main_product_str .= "<li data-marker-type='"  . $markerData['type'] . "' data-show-after-zoom-factor='" . $markerData['dataZoomAfterFactor'] . "' data-marker-id='fwd360pv" . $markerData['name'] . "' data-reg-point='" . $markerData['regpoint'] . "' data-marker-window-width='" . $markerData['window_width'] . "' data-marker-width='" . $preset['marker_width'] .  "' data-marker-height='" . $preset['marker_height'] . "' data-tooltip-offset-x='" . $marker['offsetX'] . "' data-marker-left=\"" . $marker['x'] . "\" data-marker-top=\"" . $marker['y'] . "\" data-marker-normal-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker4.png" . "' data-marker-selected-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker4-rollover.png" . "'>" .  $markerData['text'] . "</li>";
					}else if($markerData["type"] == "infowindow"){
						$main_product_str .= "<li data-marker-type='"  . $markerData['type'] . "' data-show-after-zoom-factor='" . $markerData['dataZoomAfterFactor'] . "' data-marker-id='fwd360pv" . $markerData['name'] . "' data-reg-point='" . $markerData['regpoint'] . "' data-marker-width='" . $preset['marker_width'] . "' data-tooltip-offset-x='" . $marker['offsetX'] .  "' data-marker-height='" . $preset['marker_height'] . "' data-marker-left=\"" . $marker['x'] . "\" data-marker-top=\"" . $marker['y'] . "\"  data-tool-tip-label=\"" . $markerData['name'] . "\" data-marker-normal-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker2.png" . "' data-marker-selected-state-path='" . $this->_dir_url . "content/" . $preset['skin_path'] . "/marker2-rollover.png" . "'>" .  $markerData['text'] . "</li>";
					}
				}
			}
			
		}
	
		
		$main_product_str .=  "</ul>";
		$main_product_str .=  "</div>";
		
    	return $main_product_str;
    }
}

?>